Ipopt 3.12.10

- Main Page
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Public Member Functions | Private Member Functions | Private Attributes | List of all members
Ipopt::CompoundSymMatrix Class Reference

Class for symmetric matrices consisting of other matrices. More...

`#include <IpCompoundSymMatrix.hpp>`

Inheritance diagram for Ipopt::CompoundSymMatrix:
[legend]

## Public Member Functions
void | SetComp (Index irow, Index jcol, const Matrix &matrix)
| Method for setting an individual component at position (irow, icol) in the compound matrix. More...
void | SetCompNonConst (Index irow, Index jcol, Matrix &matrix)
| Non const version of the same method. More...
SmartPtr< const Matrix > | GetComp (Index irow, Index jcol) const
| Method for retrieving one block from the compound matrix. More...
SmartPtr< Matrix > | GetCompNonConst (Index irow, Index jcol)
| Non const version of GetComp. More...
SmartPtr< CompoundSymMatrix > | MakeNewCompoundSymMatrix () const
| Method for creating a new matrix of this specific type. More...
Index | NComps_Dim () const
| Number of block rows and columns. More...
Constructors / Destructors
| CompoundSymMatrix (const CompoundSymMatrixSpace *owner_space)
| Constructor, taking only the number for block components into the row and column direction. More...
| ~CompoundSymMatrix ()
| Destructor. More...
Public Member Functions inherited from Ipopt::SymMatrix
SmartPtr< const SymMatrixSpace > | OwnerSymMatrixSpace () const
| SymMatrix (const SymMatrixSpace *owner_space)
| Constructor, taking the owner_space. More...
virtual | ~SymMatrix ()
| Destructor. More...
Index | Dim () const
| Dimension of the matrix (number of rows and columns) More...
Public Member Functions inherited from Ipopt::Matrix
bool | HasValidNumbers () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan). More...
SmartPtr< const MatrixSpace > | OwnerSpace () const
| Return the owner MatrixSpace. More...
| Matrix (const MatrixSpace *owner_space)
| Constructor. More...
virtual | ~Matrix ()
| Destructor. More...
void | MultVector (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply. More...
void | TransMultVector (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix(transpose) vector multiply. More...
void | AddMSinvZ (Number alpha, const Vector &S, const Vector &Z, Vector &X) const
| X = X + alpha*(Matrix S^{-1} Z). More...
void | SinvBlrmZMTdBr (Number alpha, const Vector &S, const Vector &R, const Vector &Z, const Vector &D, Vector &X) const
| X = S^{-1} (r + alpha*Z*M^Td). More...
Index | NRows () const
| Number of rows. More...
Index | NCols () const
| Number of columns. More...
void | ComputeRowAMax (Vector &rows_norms, bool init=true) const
| Compute the max-norm of the rows in the matrix. More...
void | ComputeColAMax (Vector &cols_norms, bool init=true) const
| Compute the max-norm of the columns in the matrix. More...
virtual void | Print (SmartPtr< const Journalist > jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent=0, const std::string &prefix="") const
| Print detailed information about the matrix. More...
virtual void | Print (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent=0, const std::string &prefix="") const
Public Member Functions inherited from Ipopt::TaggedObject
| TaggedObject ()
| Constructor. More...
virtual | ~TaggedObject ()
| Destructor. More...
Tag | GetTag () const
| Users of TaggedObjects call this to update their own internal tags every time they perform the expensive operation. More...
bool | HasChanged (const Tag comparison_tag) const
| Users of TaggedObjects call this to check if the object HasChanged since they last updated their own internal tag. More...
Public Member Functions inherited from Ipopt::ReferencedObject
| ReferencedObject ()
virtual | ~ReferencedObject ()
Index | ReferenceCount () const
void | AddRef (const Referencer *referencer) const
void | ReleaseRef (const Referencer *referencer) const
Public Member Functions inherited from Ipopt::Subject
| Subject ()
| Default Constructor. More...
virtual | ~Subject ()
| Default destructor. More...
void | AttachObserver (Observer::NotifyType notify_type, Observer *observer) const
| Attach the specified observer (i.e., begin recieving notifications). More...
void | DetachObserver (Observer::NotifyType notify_type, Observer *observer) const
| Detach the specified observer (i.e., no longer recieve notifications). More...

## Protected Member Functions
Methods overloaded from matrix
virtual void | MultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply. More...
virtual bool | HasValidNumbersImpl () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan). More...
virtual void | ComputeRowAMaxImpl (Vector &rows_norms, bool init) const
| Compute the max-norm of the rows in the matrix. More...
virtual void | PrintImpl (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent, const std::string &prefix) const
| Print detailed information about the matrix. More...
Protected Member Functions inherited from Ipopt::SymMatrix
virtual void | TransMultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Since the matrix is symmetric, it is only necessary to implement the MultVectorImpl method in a class that inherits from this base class. More...
virtual void | ComputeColAMaxImpl (Vector &cols_norms, bool init) const
| Since the matrix is symmetric, the row and column max norms are identical. More...
Protected Member Functions inherited from Ipopt::Matrix
virtual void | AddMSinvZImpl (Number alpha, const Vector &S, const Vector &Z, Vector &X) const
| X = X + alpha*(Matrix S^{-1} Z). More...
virtual void | SinvBlrmZMTdBrImpl (Number alpha, const Vector &S, const Vector &R, const Vector &Z, const Vector &D, Vector &X) const
| X = S^{-1} (r + alpha*Z*M^Td). More...
Protected Member Functions inherited from Ipopt::TaggedObject
void | ObjectChanged ()
| Objects derived from TaggedObject MUST call this method every time their internal state changes to update the internal tag for comparison. More...
Protected Member Functions inherited from Ipopt::Subject
void | Notify (Observer::NotifyType notify_type) const

## Private Member Functions
bool | MatricesValid () const
| method to check wether or not the matrices are valid More...
const Matrix * | ConstComp (Index irow, Index jcol) const
| Internal method to return a const pointer to one of the comps. More...
Matrix * | Comp (Index irow, Index jcol)
| Internal method to return a non-const pointer to one of the comps. More...
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| CompoundSymMatrix ()
| Default Constructor. More...
| CompoundSymMatrix (const CompoundSymMatrix &)
| Copy Constructor. More...
void | operator= (const CompoundSymMatrix &)
| Overloaded Equals Operator. More...

## Private Attributes
std::vector< std::vector < SmartPtr< Matrix > > > | comps_
| Vector of vectors containing the components. More...
std::vector< std::vector < SmartPtr< const Matrix > > > | const_comps_
| Vector of vectors containing the const components. More...
const CompoundSymMatrixSpace * | owner_space_
| Copy of the owner_space ptr as a CompoundSymMatrixSpace. More...
bool | matrices_valid_
| boolean indicating if the compound matrix is in a "valid" state More...

## Additional Inherited Members
Public Types inherited from Ipopt::TaggedObject
typedef unsigned int | Tag
| Type for the Tag values. More...

## Detailed Description

Class for symmetric matrices consisting of other matrices.

Here, the lower left block of the matrix is stored.

Definition at line 24 of file IpCompoundSymMatrix.hpp.

## Constructor & Destructor Documentation

Ipopt::CompoundSymMatrix::CompoundSymMatrix | ( | const CompoundSymMatrixSpace * | owner_space | ) |

Constructor, taking only the number for block components into the row and column direction.

The owner_space has to be defined, so that at each block row and column contain at least one non-NULL component.

Ipopt::CompoundSymMatrix::~CompoundSymMatrix | ( |  | ) |

Destructor.

Ipopt::CompoundSymMatrix::CompoundSymMatrix | ( |  | ) |
| private

Default Constructor.

Ipopt::CompoundSymMatrix::CompoundSymMatrix | ( | const CompoundSymMatrix & |  | ) |
| private

Copy Constructor.

## Member Function Documentation

void Ipopt::CompoundSymMatrix::SetComp | ( | Index | irow,
|  | Index | jcol,
|  | const Matrix & | matrix
| ) |  |

Method for setting an individual component at position (irow, icol) in the compound matrix.

The counting of indices starts at 0. Since this only the lower left components are stored, we need to have jcol<=irow, and if irow==jcol, the matrix must be a SymMatrix

void Ipopt::CompoundSymMatrix::SetCompNonConst | ( | Index | irow,
|  | Index | jcol,
|  | Matrix & | matrix
| ) |  |

Non const version of the same method.

SmartPtr<const Matrix> Ipopt::CompoundSymMatrix::GetComp | ( | Index | irow,
|  | Index | jcol
| ) |  | const
| inline

Method for retrieving one block from the compound matrix.

Since this only the lower left components are stored, we need to have jcol<=irow

Definition at line 54 of file IpCompoundSymMatrix.hpp.

SmartPtr<Matrix> Ipopt::CompoundSymMatrix::GetCompNonConst | ( | Index | irow,
|  | Index | jcol
| ) |  |
| inline

Non const version of GetComp.

You should only use this method if you are intending to change the matrix you receive, since this CompoundSymMatrix will be marked as changed.

Definition at line 62 of file IpCompoundSymMatrix.hpp.

SmartPtr< CompoundSymMatrix > Ipopt::CompoundSymMatrix::MakeNewCompoundSymMatrix | ( |  | ) | const
| inline

Method for creating a new matrix of this specific type.

Definition at line 277 of file IpCompoundSymMatrix.hpp.

Index Ipopt::CompoundSymMatrix::NComps_Dim | ( |  | ) | const

Number of block rows and columns.

virtual void Ipopt::CompoundSymMatrix::MultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y
| ) |  | const
| protected virtual

Matrix-vector multiply.

Computes y = alpha * Matrix * x + beta * y

Implements Ipopt::Matrix.

virtual bool Ipopt::CompoundSymMatrix::HasValidNumbersImpl | ( |  | ) | const
| protected virtual

Method for determining if all stored numbers are valid (i.e., no Inf or Nan).

Reimplemented from Ipopt::Matrix.

virtual void Ipopt::CompoundSymMatrix::ComputeRowAMaxImpl | ( | Vector & | rows_norms,
|  | bool | init
| ) |  | const
| protected virtual

Compute the max-norm of the rows in the matrix.

The result is stored in rows_norms. The vector is assumed to be initialized.

Implements Ipopt::Matrix.

virtual void Ipopt::CompoundSymMatrix::PrintImpl | ( | const Journalist & | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent,
|  | const std::string & | prefix
| ) |  | const
| protected virtual

Print detailed information about the matrix.

Implements Ipopt::Matrix.

void Ipopt::CompoundSymMatrix::operator= | ( | const CompoundSymMatrix & |  | ) |
| private

Overloaded Equals Operator.

bool Ipopt::CompoundSymMatrix::MatricesValid | ( |  | ) | const
| private

method to check wether or not the matrices are valid

const Matrix* Ipopt::CompoundSymMatrix::ConstComp | ( | Index | irow,
|  | Index | jcol
| ) |  | const
| inline private

Internal method to return a const pointer to one of the comps.

Definition at line 136 of file IpCompoundSymMatrix.hpp.

Matrix* Ipopt::CompoundSymMatrix::Comp | ( | Index | irow,
|  | Index | jcol
| ) |  |
| inline private

Internal method to return a non-const pointer to one of the comps.

Definition at line 151 of file IpCompoundSymMatrix.hpp.

## Member Data Documentation

std::vector<std::vector<SmartPtr<Matrix> > > Ipopt::CompoundSymMatrix::comps_
| private

Vector of vectors containing the components.

Definition at line 121 of file IpCompoundSymMatrix.hpp.

std::vector<std::vector<SmartPtr<const Matrix> > > Ipopt::CompoundSymMatrix::const_comps_
| private

Vector of vectors containing the const components.

Definition at line 124 of file IpCompoundSymMatrix.hpp.

const CompoundSymMatrixSpace* Ipopt::CompoundSymMatrix::owner_space_
| private

Copy of the owner_space ptr as a CompoundSymMatrixSpace.

Definition at line 127 of file IpCompoundSymMatrix.hpp.

bool Ipopt::CompoundSymMatrix::matrices_valid_
| mutable private

boolean indicating if the compound matrix is in a "valid" state

Definition at line 130 of file IpCompoundSymMatrix.hpp.

The documentation for this class was generated from the following file:

- src/LinAlg/IpCompoundSymMatrix.hpp